/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_AUDIO)

#include "JSAudioNode.h"
#include "JSDOMWrapper.h"
#include "WebKitDynamicsCompressorNode.h"

namespace WebCore {

class JSWebKitDynamicsCompressorNode : public JSAudioNode {
public:
    using Base = JSAudioNode;
    using DOMWrapped = WebKitDynamicsCompressorNode;
    static JSWebKitDynamicsCompressorNode* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<WebKitDynamicsCompressorNode>&& impl)
    {
        JSWebKitDynamicsCompressorNode* ptr = new (NotNull, JSC::allocateCell<JSWebKitDynamicsCompressorNode>(globalObject->vm().heap)) JSWebKitDynamicsCompressorNode(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    template<typename, JSC::SubspaceAccess mode> static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    WebKitDynamicsCompressorNode& wrapped() const
    {
        return static_cast<WebKitDynamicsCompressorNode&>(Base::wrapped());
    }
protected:
    JSWebKitDynamicsCompressorNode(JSC::Structure*, JSDOMGlobalObject&, Ref<WebKitDynamicsCompressorNode>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, WebKitDynamicsCompressorNode&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebKitDynamicsCompressorNode* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<WebKitDynamicsCompressorNode>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<WebKitDynamicsCompressorNode>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<WebKitDynamicsCompressorNode> {
    using WrapperClass = JSWebKitDynamicsCompressorNode;
    using ToWrappedReturnType = WebKitDynamicsCompressorNode*;
};

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
